import { ITreeNodeModel } from '@zeedhi/common';

export class AclLabelsService {
	private static allLabels: Array<string> = [];

	private static arrayOfObject: Array<ITreeNodeModel<any>> = [];

	public static getAllLabelsInNodes(nodes: Array<ITreeNodeModel<any>>): Array<string> {
		this.allLabels = [];
		this.iterateChildrenNodes(nodes);

		return this.allLabels;
	}

	private static iterateChildrenNodes(nodes: Array<ITreeNodeModel<any>>) {
		nodes.forEach((node) => {
			if (node.data.label) {
				this.allLabels.push(node.data.label);
			}

			if (node.children?.length) {
				this.iterateChildrenNodes(node.children);
			}
		});
	}

	public static convertNodeToArrayOfObjectPlain(nodes: Array<ITreeNodeModel<any>>) {
		this.arrayOfObject = [];
		this.defineObjectPlain(nodes);
		return this.arrayOfObject;
	}

	private static defineObjectPlain(nodes: Array<ITreeNodeModel<any>>) {
		nodes.forEach((node) => {
			this.arrayOfObject.push(node);
			if (node.children?.length) {
				this.defineObjectPlain(node.children);
			}
		});
	}

	public static getMajorVersion(nodes: Array<ITreeNodeModel<any>>): number {
		let majorVersion = 0;
		const array = AclLabelsService.convertNodeToArrayOfObjectPlain(nodes);
		array.forEach((node) => {
			if (node.data.version && node.data.version > majorVersion) {
				majorVersion = parseInt(node.data.version, 10);
			}
		});
		return majorVersion;
	}
}
